package rules2cp.examples.packing;
import static rules2cp.interpreter.java.r2cp.*;
import rules2cp.interpreter.java.*;
import java.util.Vector;
import static choco.Choco.*;
import choco.cp.model.CPModel;
import choco.cp.solver.CPSolver;
import choco.cp.solver.search.integer.varselector.*;
import choco.cp.solver.search.integer.valselector.*;
import choco.cp.solver.search.integer.valiterator.*;
import choco.cp.solver.search.integer.branching.*;
import choco.cp.solver.constraints.integer.*;
import choco.cp.solver.constraints.global.geost.Constants;
import choco.cp.solver.constraints.global.geost.externalConstraints.ExternalConstraint;
import choco.cp.solver.constraints.global.geost.externalConstraints.NonOverlapping;
import choco.cp.solver.constraints.global.geost.geometricPrim.ShiftedBox;
import choco.kernel.model.Model;
import choco.kernel.model.constraints.*;
import choco.kernel.model.variables.*;
import choco.kernel.model.variables.integer.*;
import choco.kernel.model.variables.geost.GeostObject;
import choco.kernel.solver.Solver;
import choco.kernel.solver.branch.*;
import choco.kernel.solver.variables.integer.*;
import choco.kernel.model.variables.geost.*;

public class packing_polymorphism {

  public static void main(String[] args) {

    IntegerVariable reif_126 = makeIntVar("reif_126", 0, 1);
    IntegerVariable reif_127 = makeIntVar("reif_127", 0, 1);
    IntegerVariable reif_128 = makeIntVar("reif_128", 0, 1);
    IntegerVariable reif_129 = makeIntVar("reif_129", 0, 1);
    IntegerVariable reif_130 = makeIntVar("reif_130", 0, 1);
    IntegerVariable reif_131 = makeIntVar("reif_131", 0, 1);
    IntegerVariable reif_132 = makeIntVar("reif_132", 0, 1);
    IntegerVariable reif_133 = makeIntVar("reif_133", 0, 1);
    IntegerVariable reif_134 = makeIntVar("reif_134", 0, 1);
    IntegerVariable reif_135 = makeIntVar("reif_135", 0, 1);
    IntegerVariable reif_136 = makeIntVar("reif_136", 0, 1);
    IntegerVariable reif_137 = makeIntVar("reif_137", 0, 1);
    IntegerVariable o3_4 = rcp_var("from(o3, 4)");
    IntegerVariable o3_3 = rcp_var("from(o3, 3)");
    IntegerVariable o3 = rcp_var("from(o3, 1)");
    IntegerVariable o3_2 = rcp_var("from(o3, 2)");
    IntegerVariable o2_4 = rcp_var("from(o2, 4)");
    IntegerVariable o2_3 = rcp_var("from(o2, 3)");
    IntegerVariable o2 = rcp_var("from(o2, 1)");
    IntegerVariable o2_2 = rcp_var("from(o2, 2)");
    addConstraint(reifiedIntConstraint(reif_126, eq(o2_4, 1)));
    addConstraint(reifiedIntConstraint(reif_127, eq(o2_4, 2)));
    addConstraint(reifiedIntConstraint(reif_128, eq(o2_4, 1)));
    addConstraint(reifiedIntConstraint(reif_129, eq(o2_4, 2)));
    addConstraint(reifiedIntConstraint(reif_130, eq(o2_4, 1)));
    addConstraint(reifiedIntConstraint(reif_131, eq(o2_4, 2)));
    addConstraint(reifiedIntConstraint(reif_132, eq(o3_4, 1)));
    addConstraint(reifiedIntConstraint(reif_133, eq(o3_4, 2)));
    addConstraint(reifiedIntConstraint(reif_134, eq(o3_4, 1)));
    addConstraint(reifiedIntConstraint(reif_135, eq(o3_4, 2)));
    addConstraint(reifiedIntConstraint(reif_136, eq(o3_4, 1)));
    addConstraint(reifiedIntConstraint(reif_137, eq(o3_4, 2)));
    domain(new IntegerVariable[] {o2}, 0, 5);
    domain(new IntegerVariable[] {o2_2}, 0, 4);
    domain(new IntegerVariable[] {o2_3}, 0, 4);
    domain(new IntegerVariable[] {o3}, 0, 5);
    domain(new IntegerVariable[] {o3_2}, 0, 4);
    domain(new IntegerVariable[] {o3_3}, 0, 4);
    domain(new IntegerVariable[] {o2_4}, 1, 2);
    domain(new IntegerVariable[] {o3_4}, 1, 2);
    addConstraint(leq(0, o2));
    addConstraint(leq(plus(o2, plus(mult(reif_126, 4), mult(reif_127, 5))), 5));
    addConstraint(leq(0, o2_2));
    addConstraint(leq(plus(o2_2, plus(mult(reif_128, 5), mult(reif_129, 4))), 4));
    addConstraint(leq(0, o2_3));
    addConstraint(leq(plus(o2_3, plus(mult(reif_130, 2), mult(reif_131, 2))), 4));
    addConstraint(leq(0, o3));
    addConstraint(leq(plus(o3, plus(mult(reif_132, 4), mult(reif_133, 5))), 5));
    addConstraint(leq(0, o3_2));
    addConstraint(leq(plus(o3_2, plus(mult(reif_134, 5), mult(reif_135, 4))), 4));
    addConstraint(leq(0, o3_3));
    addConstraint(leq(plus(o3_3, plus(mult(reif_136, 2), mult(reif_137, 2))), 4));
    Vector<GeostObject> geost_obj = new Vector<GeostObject>();
    Vector<ShiftedBox> geost_sb = new Vector<ShiftedBox>();
    IntegerVariable start_7 = makeIntVar("start_7", 0, 0);
    IntegerVariable duration_7 = makeIntVar("duration_7", 1, 1);
    IntegerVariable end_7 = makeIntVar("end_7", 1, 1);
    int[]  values_7 = new int[] {3, 6};
    IntegerVariable sid_7 = makeIntVar("values_7", values_7, "cp:enum");
    geost_obj.add(new GeostObject(3, 7, sid_7, new IntegerVariable[] {o2, o2_2, o2_3}, start_7, duration_7, end_7));
    IntegerVariable start_8 = makeIntVar("start_8", 0, 0);
    IntegerVariable duration_8 = makeIntVar("duration_8", 1, 1);
    IntegerVariable end_8 = makeIntVar("end_8", 1, 1);
    int[]  values_8 = new int[] {3, 6};
    IntegerVariable sid_8 = makeIntVar("values_8", values_8, "cp:enum");
    geost_obj.add(new GeostObject(3, 8, sid_8, new IntegerVariable[] {o3, o3_2, o3_3}, start_8, duration_8, end_8));
    geost_sb.add(new ShiftedBox(3, new int[] {0, 0, 0}, new int[] {4, 5, 2}));
    geost_sb.add(new ShiftedBox(6, new int[] {0, 0, 0}, new int[] {5, 4, 2}));
    addConstraint(geost(3, geost_obj, geost_sb, non_overlapping(3, geost_obj)));
    Solver s = new CPSolver();
    s.read(rules2cp.interpreter.java.r2cp.model);
    CPSolver.setVerbosity(CPSolver.SEARCH);
    s.post(new Element(s.getVar(o3_4), values_8, s.getVar(sid_8), -1));
    s.post(new Element(s.getVar(o2_4), values_7, s.getVar(sid_7), -1));
    s.attachGoal(new AssignVar(new StaticVarOrder(s.getVar(new IntegerVariable[] {o3_4, o3_3, o3, o3_2, o2_4, o2_3, o2, o2_2})), new IncreasingDomain()));
    s.generateSearchStrategy();
    s.launch();
    CPSolver.flushLogs();
    System.out.println(s.pretty());
    
  }

}
