:-use_module(library(lists)).
:-use_module(library(clpfd)).
:-ensure_loaded(geosr).

/* a first translation of packing.rcp to geosr by hand */

packing_geosr([O1_,O1_2,O1_3, O2_,O2_2,O2_3]) :-
	
	O1_ in 0..5, O1_2 in 0..4, O1_3 in 0..4,
	O2_ in 0..5, O2_2 in 0..4, O2_3 in 0..4,
	
	geosr([object(1,1,[0,0,0],[]),
	       object(2,2,[O1_,O1_2,O1_3],[]),
	       object(3,2,[O2_,O2_2,O2_3],[])],
	      
	      [sbox(1,[0,0,0],[5,4,4]),
	       sbox(2,[0,0,0],[5,4,2]),
	       sbox(3,[0,0,0],[4,4,2])],
	      
	      [(origin(O,D) ---> O^x(D)),
	       
	       (size(S,D) ---> S^l(D)),
	       
	       (end(O,D) ---> origin(O, D) + fold(S, sboxes([O^sid]), +, 0, size(S, D))),
	       
	       (overlap(O1, O2, D) --->
		   end(O1,D) #> origin(O2,D) #/\
	           end(O2,D) #> origin(O1,D)),
	       
	       (contains(O1,O2,D) --->
		   origin(O1,D) #=< origin(O2,D) #/\ 
	           end(O2,D) #=< end(O1,D)),
	       
	       (non_overlapping(Items, Dims) --->
		   forall(O1, Items, 
		      forall(O2, Items, 
		         exists(D, Dims, 
		            O1^oid #< O2^oid #=>
			    #\ overlap(O1,O2,D))))),

	       (containmentAE(Items, Bins, Dims) --->
		   forall(I, Items, 
		      exists(B, Bins, 
		         forall(D, Dims, contains(B,I,D))))),

	       (binpacking(Items, Bins, Dims) --->
		   containmentAE(Items, Bins, Dims) #/\ 
	           non_overlapping(Items, Dims)),
	       
	       binpacking(objects([2,3]), objects([1]), [1,2,3])]),
	fd_statistics,
	statistics,
	labeling([O1_,O1_2,O1_3, O2_,O2_2,O2_3]),
	statistics,
	fd_statistics.

labeling(L) :-
	setof(L,labeling([], L), _).