:- use_module(library(lists)).
:- use_module(library(clpfd)).
:- ensure_loaded('geosr.pl').
 
psa_geosr([O1_,O1_2,O1_3, O2_,O2_2,O2_3]) :-
	
	O1_ in 0..1203, O1_2 in 0..235, O1_3 in 0..239,
	O2_ in 0..1203, O2_2 in 0..235, O2_3 in 0..239,
	
	geosr([object(1, 1, [O1_,O1_2,O1_3], []),
	       object(2, 2, [O2_,O2_2,O2_3], [])],
	      
	      [sbox(1, [0,0,0], [224, 224, 222]),
	       sbox(2, [0,0,0], [224, 224, 148])],
	      
	      [(origin(O,D) ---> O^x(D)),
	       
	       (size(S,D) ---> S^l(D)),
	       
	       (end(O,D) ---> origin(O, D) + fold(S, sboxes([O^sid]), +, 0, size(S, D))),
	       
	       (overlap_sym(O1, O2, D) --->
		   end(O1,D) #> origin(O2,D) #/\
	           end(O2,D) #> origin(O1,D)),
	       
	       (overlap(O1, O2, Dims) ---> forall(D, Dims, overlap_sym(O1, O2, D))),
	       
	       (non_overlapping(Items, Dims) --->
		   forall(O1, Items, 
		      forall(O2, Items,
			     O1^oid #< O2^oid #=>
			    #\ overlap(O1,O2,Dims)))),
	       	       	       	       
	       non_overlapping(objects([1,2]), [1,2,3])]),

	labeling([], [O1_,O1_2,O1_3, O2_,O2_2,O2_3]).
